#! perl
use strict;
use CGI qw/:standard/;

require Gesamt;

go(); # Los!!

sub go{
	
	#Hier werden die 3 Parameter "what" (was angezeigt werden soll), "mode" (wie es geordnet werden soll) und "Titel" (welche Analysedatei angezeigt werden soll).
	my $what = param('what'); #Hier: ">X" = X ist das Wort, von dem die Details gezeigt werden sollen. "all" = bersicht aller Worte
	my $mode = param('mode'); #Hier: "alpha" = nach Alphabet. "quanti" = nach Quantitt GEORDNET!!
	my $Titel = param('Titel'); #Her: Titel der Datei (ohne .dat)

	my $Text; #Hier kommt die GELADENE Datei rein.
	my $Zeile; #Aber erstmal in Zeilen
	my %Daten; #Hier kommen die Daten rein, nachdem sie in ein Hash umgewandelt wurden.
	
	
	if($Titel eq ""){ #Leerer Titel?
		DateiFehlt();#Wenn nicht: Fehlermeldung
		return; #und Ende!
	}

	open(TX,"$Titel.aly"); #AnalyseDatei ffnen
		
		while ( defined ($Zeile = <TX>) ){
			$Text .= $Zeile; #Zeilen einzeln einlesen.
		}
		
	close(TX); #AnalyseDatei Schlieen
	
	if($Text eq ""){ #Ist das was?
		DateiFehlt($Titel);#Wenn nicht: Fehlermeldung
		return; #und Ende!
	}
	%Daten = eval("($Text)"); # Umwandlung in Hash!!!

	#Was wird gewollt?
	
	if($what eq "all"){ #Alles
		All($Titel, $mode, %Daten);
	}

	if($what =~ /\<(.+)/){ #Bestimmtes Wort
		SpecWort($Titel, $1, $mode, %Daten);
	}
}







sub All(){
	my ($Titel, $mode, %Daten) = @_;
	
	
	my %Tabelle;
	foreach my $AktuellerDatensatz (sort keys %Daten)
	{
		$Tabelle{$AktuellerDatensatz} = $Daten{$AktuellerDatensatz}{"OWort"} . " " . $Daten{$AktuellerDatensatz}{"HowMany"}
	}
		
	if($mode eq "alpha")
	{
		print header,
		start_html("$Titel: Alle Wrter - alphabetisch geordnet"),
			style({-type=>"text/css"}, Stil()),
			ZurueckZurHauptseite(),
			AnalyseDateienAnzeigen("all", $mode, $Titel),
			hr(),
			table({-border=>1,-style=>'height: 90%',-align=>'center'},Alpha($Titel,"all" ,%Tabelle)),
		end_html;
	}
	
	if($mode eq "quanti")
	{
		print header,
		start_html("$Titel: Alle Wrter - nach Anzahl geordnet"),
			style({-type=>"text/css"}, Stil()),
			ZurueckZurHauptseite(),
			AnalyseDateienAnzeigen("all", $mode, $Titel),
			hr(),
			table({-border=>1,-style=>'height: 90%',-align=>'center'},Quanti($Titel,"all" ,%Tabelle)),
		end_html;
	}
}



	

sub SpecWort(){
	my ($Titel, $Wort, $mode, %Daten) = @_;
		
	unless(defined($Daten{$Wort})) #Ist das Wort da?
	{
		WortFehlt($mode, $Wort, $Titel, %Daten); #Wenn nein: Fehlermeldung
		return; #und raus hier!
	}
	
	my %Tabelledavor;
	my %Tabelledanch;
		
	#_________________________________Davor!!!
	foreach my $AktuellesWort (sort keys %Daten=>{$Wort}=>{'davor'})
	{
		if(defined($Daten{$Wort}{"davor"}{$AktuellesWort}))
		{
			$Tabelledavor{$AktuellesWort} = $Daten{$AktuellesWort}{"OWort"} . " " . $Daten{$Wort}{"davor"}{$AktuellesWort}
		}
	}
	#_________________________________Danach!!!
	foreach my $AktuellesWort (sort keys %Daten=>{$Wort}=>{'danach'})
	{
		if(defined($Daten{$Wort}{"danach"}{$AktuellesWort}))
		{
			$Tabelledanch{$AktuellesWort} = $Daten{$AktuellesWort}{"OWort"} . " " . $Daten{$Wort}{"danach"}{$AktuellesWort}
		}
	}
	
	my $OrgWort = $Daten{$Wort}{"OWort"};
	$OrgWort =~ s/<,,>/;/g; #In letzter Sekunde: <,,> -> ;

	
	if($mode eq "alpha")
	{
		print header(),
		start_html(-title=>"$Titel: " . $OrgWort . " - nach Alphabet geordnet"),
			style({-type=>"text/css"}, Stil()),
			ZurueckZurHauptseite(),
			AnalyseDateienAnzeigen("&lt;$Wort", $mode, $Titel),
			hr(),
			p({-align=>'center'}, a({-href=>"Show.pl?Titel=$Titel&mode=alpha&what=all"},"Alle Wrter - nach Alphabet geordnet")),
			hr(),
			h1({-align=>'center'}, $OrgWort),
			h3({-align=>'center'}, '< Worte davor | Worte danach >'),
			h3({-align=>'center'}, "Anzahl:    " . $Daten{$Wort}{"HowMany"}),
			table({-class=>"davor"},Alpha($Titel,"<$Wort" ,%Tabelledavor)),
			table({-class=>"danach"},Alpha($Titel,"<$Wort" ,%Tabelledanch)),
		end_html;
	}
	
	if($mode eq "quanti")
	{
		print header,
		start_html("$Titel: " . $OrgWort . " - nach Anzahl geordnet"),
			style({-type=>"text/css"}, Stil()),
			ZurueckZurHauptseite(),
			AnalyseDateienAnzeigen("&lt;$Wort", $mode, $Titel),
			hr(),
			p({-align=>'center'}, a({-href=>"Show.pl?Titel=$Titel&mode=quanti&what=all"},"Alle Wrter - nach Anzahl geordnet")),
			hr(),
			h1({-align=>'center'}, $OrgWort),
			h3({-align=>'center'}, '< Worte davor | Worte danach >'),
			h3({-align=>'center'}, "Anzahl:    " . $Daten{$Wort}{"HowMany"}),
			table({-class=>"davor"},Quanti($Titel,"<$Wort" ,%Tabelledavor)),
			table({-class=>"danach"},Quanti($Titel,"<$Wort" ,%Tabelledanch)),
		end_html;
	}
}	
	

sub Alpha(){
	my ($Titel, $What, %Tabelle) = @_;
	my $TabelleHTML;
	my $AktuellerAnfangsbuchstabe = "";
	my $ABuchKani; #Anfangsbuchstabenkanidat
	
	
	
	$TabelleHTML = Tr(
		td({-align=>'center'}, a({-href=>"Show.pl?Titel=$Titel&mode=alpha&what=$What"},"Worte" , br() , "(alphabetisch)")),
		td({-align=>'center'}, a({-href=>"Show.pl?Titel=$Titel&mode=quanti&what=$What"},"Anzahl" , br() , "(numerisch)")),
	);	
	
	foreach my $AktuellerDatensatz (sort keys %Tabelle)
	{
		
		$AktuellerDatensatz =~ /^([a-z])/;
		$ABuchKani = $1;
		
		if(	!($ABuchKani eq $AktuellerAnfangsbuchstabe) and ($ABuchKani =~ /^[a-z]$/)	)
		{
			$AktuellerAnfangsbuchstabe = $ABuchKani;
			$TabelleHTML .= Tr(td({-colspan=>'2' , -align=>'center'}, h2(uc($AktuellerAnfangsbuchstabe))));		
			
		}
			
			
		i	

		
		my($OrgWort, $Anzahl) = split(" ", $Tabelle{$AktuellerDatensatz});
		
		if(defined($OrgWort) and defined($Anzahl))
		{
			$OrgWort =~ s/<,,>/;/g; #In letzter Sekunde: <,,> -> ;
		
			$TabelleHTML .= Tr(
				td({-align=>'center'},
					a({-href=>"Show.pl?Titel=$Titel&mode=alpha&what=<$AktuellerDatensatz"},
					$OrgWort
				)
			),
				td({-align=>'center'},
					$Anzahl
				)
			);
		}
	
	}
	
	return $TabelleHTML;
	
}


sub Quanti(){
	my ($Titel, $What, %Tabelle) = @_;
	my %Sort;
	my $TabelleHTML;
	
	$TabelleHTML = Tr(
		td({-align=>'center'}, a({-href=>"Show.pl?Titel=$Titel&mode=alpha&what=$What"},"Worte" , br() , "(alphabetisch)")),
		td({-align=>'center'}, a({-href=>"Show.pl?Titel=$Titel&mode=quanti&what=$What"},"Anzahl" , br() , "(numerisch)")),
	);
	
	foreach my $AktuellerDatensatz (keys %Tabelle)
	{
		my($OrgWort, $Anzahl) = split(" ", $Tabelle{$AktuellerDatensatz});
		$Sort{$Anzahl} .= "$AktuellerDatensatz ";
	}
	
	foreach my $AktuellerDatensatz (sort {$b <=> $a} keys %Sort)
	{
		foreach my $AktuellesWort(sort split(" ", $Sort{$AktuellerDatensatz}))
		{
			my($OrgWort, $Anzahl) = split(" ", $Tabelle{$AktuellesWort});
			
			if(defined($OrgWort) and defined($Anzahl))
			{
				
				$OrgWort =~ s/<,,>/;/g; #In letzter Sekunde: <,,> -> ;



				$TabelleHTML .= Tr(
					td({-align=>'center'},
						a(
							{-href=>"Show.pl?Titel=$Titel&what=<$AktuellesWort&mode=quanti"},
							$OrgWort
						)
					),
					td(
						{-align=>'center'},
						$AktuellerDatensatz
					)
				);
			
			}
		}
	}
	
	return $TabelleHTML;
	
}